LeetCode每日一题之 移动0

前言:

我的每日一题专栏正式开始更新,我会分享关于我在LeetCode上刷题时的经验,将经典题型拿出来详细讲解,来提升自己及大家的算法能力,希望这篇博客对大家有帮助。

题目介绍:

题目链接:. - 力扣(LeetCode)

算法原理:

很明显这是一类数组划分的题目,那么这类题目常用解法,可以使用双指针法,注意这里提到的双指针是下标(索引),不是c语言中的指针。

总所周知,两个指针会将整个数组分为3个区域,如下图:

如果我们我们能将数组的元素,按如下图划分:

也就是dest指向已处理的非0元素的最后一个,cur指向未处理元素的第一个,按照这样的规则走下去,当cur走到数组末端的时候,整个数组就变成了我们想要的样子。

那么如何遵循这样的规则往下走了,就是我们的算法体现了,看下面这个例子:

两个指针初始状态:

dest -1 (dest指向已处理的最后一个元素,现在没有已处理的元素,所以指向-1)

cur 0 (cur要遍历整个数组,所以从0开始)

下面介绍每个指针的行动规则:

cur:cur遇到0,cur++

dest:cur遇到非0,++dest,然后交换dest和cur对应的值,交换完后cur++

下面用上面的例子走一遍:

cur遇到第一个元素0,cur++:

cur遇到第二个元素1,非0, ++dest,然后交换dest和cur对应的值再cur++:

其实不难看出这已经到了我们上面的理想状态了,区域1是已处理的元素,区域2是0,区域3是未处理的,且dest指向已处理元素的最后一个,cur指向未处理元素的第一个。

继续, cur遇到第三个元素0,cur++:

cur遇到第四个元素3,非0, ++dest,然后交换dest和cur对应的值再cur++:

cur遇到第五个元素0,cur++:

cur遇到第六个元素12,非0, ++dest,然后交换dest和cur对应的值再cur++:

此时cur走到数组末端,结束,该数组也被我们处理完毕。

代码实现:

c语言:

复制代码
void swap(int* a,int* b)//交换函数
{
    int tmp=*a;
    *a=*b;
    *b=tmp;
}
void moveZeroes(int* nums, int numsSize) {
    int dest=-1,cur=0;//两个指针的初始位置
    while(cur<numsSize)
    {
        if(nums[cur]!=0)//遇到非0时
        {
            ++dest;
            swap(&nums[dest],&nums[cur]);
        }
        cur++;//无论怎样cur都需要++,所以可以直接写在这
    }
}
相关推荐
知识分享小能手7 分钟前
C学习教程,从入门到精通,C语言学生信息管理系统 — 知识点详解(18)
c语言·学习·1024程序员节
爱读书的小胖14 分钟前
LeetCode 55 跳跃游戏 C 语言解题分析
c语言·数据结构·算法·leetcode·1024程序员节
CCblandy15 分钟前
前缀缓存命中率不靠引擎靠排列:本机仿真 3 轮,易变字段放开头 98.0%→0.0%
人工智能·python·算法·自然语言处理·性能优化
上班摸鱼下班游戏19 分钟前
Unity 仿生智能算法 从蚁群算法 开始
算法·unity·游戏引擎
pipixia2003330 分钟前
C++ 面试高频:namespace 的 6 个知识点,从 using 到匿名命名空间
c语言·学习·算法·嵌入式·命名空间·c++面试·匿名命名空间
Navigator_Z2 小时前
LeetCode //C - 1300. Sum of Mutated Array Closest to Target
c语言·算法·leetcode
SZYSK2 小时前
鸿蒙人脸识别算法放在终端里:和外挂授权 SDK 差在排障路径
物联网·算法·华为·harmonyos
凯瑟琳.奥古斯特2 小时前
力扣1016高效解法:剪枝优化技巧
开发语言·c++·算法·leetcode·职场和发展
xiangyun613 小时前
C++ priority_queue 底层:手撕二叉堆与 Top K 问题
c++·算法·面试·stl·1024程序员节
qz_Serene3 小时前
练习算法题:双指针 -cpp
c++·算法·leetcode·1024程序员节